//+------------------------------------------------------------------+
//| Christmas Tree International Hymn version                        |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2008 latimeria"
#property indicator_chart_window

// Links for multi language

// http://www.infostarbase.com/tnr/xmas/merry.html
// http://www.navidadlatina.com/idiomas/

// Links for multi language "Silent Night"

// German & English version  http://www.soundpie.com/hymn/109.htm
// French / Spanish / Italian / Norwegian version  http://www.visit-salzburg.net/travel/silentnightlyrics.htm
// more and more  http://www.silentnight.web.za/translate/

extern string  ModeExp = "<<< Mode Select >>>";
extern string  ModeNote_1 = "1=JustTree 2=Message 3=Hymn";
extern int     Mode = 3;

extern string  AutoHeightExp = "<<< Auto Height >>>";
extern bool    AutoHeight = true;
extern int     PERIOD = 100;

extern string  ManualHeightExp = "<<< Manual Height >>>";
extern double  TreeTop_Price = 1.3;
extern double  TreeBottom_Price = 1.25;

extern string  CenterExp = "<<< Auto Draw tree at the center >>>";
extern bool    DrawTreeCenter = true;

extern string  BarShiftExp = "<<< Manual BarShift >>>";
extern int     BarShift = 100;

//extern string  TwinkleExp = "<<< Twinkle Interval >>>";
//extern int     Twinkle_Interval_Sec = 1;

extern string  AboutRandomize = "<<< Randomize >>>";
extern bool    Randomize = true;
extern int     MinimumTextSize = 11;
extern int     MaximumTextSize = 40;

extern string  MultiLanguageExp = "<<< Message >>>";
extern int     Select_Language = 99;
extern int     Loop_Interval_Sec = 7;
extern string  LangNote_1 = "1=ENG 2=FRA 3=ESP 4=GER 5=RUS 6=ITA";
extern string  LangNote_2 = "7=Hindi 8=Mandarin 9=Iraqi 10=Hawaiian";
extern string  LangNote_3 = "11=Suomeksi 12=Swahili 13=Tagalog";
extern string  LangNote_4 = "14=Uzbek 15=Czech 16=Greek 17=Turkish";
extern string  LangNote_5 = "18=Punjabi 19=Euskera 20=Esperanto";
extern string  LangNote_6 = "99=Loop";
extern string  CustomMessage = "enter your words here";

extern string  HymnExp = "<<< Hymn (Silent Night) >>>";
extern string  Hymnnote_1 = "1=GER 2=ENG 3=FRA 4=ESP 5=ITA";
extern string  Hymnnote_2 = "6=Norwegian 7=Tahitian 8=Hindi 9=Euskera";
extern string  Hymnnote_3 = "10=Swahili 11=Indonesian 12=Maori";
extern string  Hymnnote_4 = "13=Hungarian 14=Irish";
extern string  Hymnnote_5 = "20=Esperanto 99=LoopMerryChristmas";
extern int     Select_Song = 99;
extern int     Hymn_Interval_Sec = 5;

extern string  ShowCurLangExp = "<<< Show Current Language >>>";
extern bool    ShowCurrentLanguage = true;

extern string  MiscellaneousExp = "<<< Miscellaneous >>>";
extern string  Font = "Arial Bold";
extern int     FontSize = 11;
extern color   FontColor = White;
extern int     TextCorner = 2;
extern int     TextLineShift = 0;

int CurTiming;

string Multi_Lang [] = { "",
                         "Merry Christmas", // ENG
                         "Joyeux Noel", // FRA
                         "Feliz Navidad", // ESP
                         "Froehliche Weihnachten", // GER
                         "S Rozhdestvom Kristovym", // RUS

                         "Buon Natale", // ITA
                         "Shub Badadin", // Hindi
                         "Sheng Dankuai Le", // Mandarin
                         "Idah Saidan Wa Sanah Jadidah", // Iraqi
                         "Mele Kalikimaka", // Hawaiian

                         "Hauskaa Joulua", // Suomeksi
                         "Heri ya Krismasi", // Swahili
                         "Maligayang Pasko", // Tagalog
                         "Yangi Yiligiz Mubarak Bolsun", // Uzbek
                         "Velike Vanoce", // Czech
                         
                         "Kala Christouyenna", // Greek
                         "Noeliniz Ve Yeni Yiliniz Kutlu Olsun", // Turkish
                         "Hacahi Ke Eide", // Punjabi
                         "Zorionak eta Urte Berri On", // Euskera
                         "Gojan Kristnaskon" // Esperanto
                       };

string Language [] = { "",
                         "English","Francaise","Espagnol","Deutsch","Ruski",
                         "Italiano","Hindi","Chinese (Mandarin)", "Iraqi","Hawaiian",
                         "Suomeksi", "Swahili","Tagalog","Uzbek","Czech",
                         "Greek","Turkish","Punjabi","Euskera", "Esperanto"
                       };

string ObjName[] = { "","Tree1","","","","Trunk","","","","","", // 0-10
                     "","","","","","","","","","", // 11-20
                     "Tree21","Tree22","Tree23","","","","","","","", // 21-30
                     "Tree31","Tree32","Tree33","","","","","","","", // 31-40
                     "Star1","Star2","Star3","Star4","Star5","Star6","Star7","Star8","","", // 41-50
                     "Light51","Light52","Light53","Light54","Light55","Light56","Light57","Light58","Light59","", // 51-60
                     "Light61","Light62","Light63","Light64","Light65","Light66","Light67","Light68","Light69","" // 61-70
                   };

int ObjNumber[] = {  1,5,
                     21,22,23,
                     31,32,33,
                     41,42,43,44,45,46,47,48,
                     51,52,53,54,55,56,57
                  };

bool SIGNAL;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   SIGNAL = true;
   if(ShowCurrentLanguage) Comment("");
   return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   for(int i=0; i<=22; i++)
   {
      ObjectDelete( ObjName[ ObjNumber[i] ] );
   }
   ObjectDelete("MESSAGE");
   if(ShowCurrentLanguage) Comment("");
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   DrawCristmasTree();
   
   return(0);
}
  
//+------------------------------------------------------------------+
//| DrawCristmasTree()                                               |
//+------------------------------------------------------------------+
void DrawCristmasTree()
{
   for(int i=0; i<=22; i++)
   {
      ObjectDelete( ObjName[ ObjNumber[i] ] );
   }
   
   color LEAF_COL = Green;
   color TRUNK_COL = SaddleBrown;
   color TOPSTAR_COL = Gold;

   double TreeTop = TreeTop_Price;
   double TreeBottom = TreeBottom_Price;

   if(AutoHeight)
   {
      TreeTop = Low[ PERIOD ];
      TreeBottom = Close[0];
      if(TreeTop < TreeBottom) 
      {
         TreeTop = Close[0];
         TreeBottom = High[ PERIOD ];
      }
   }
   
   int Base = BarShift;
   if(DrawTreeCenter) Base = WindowBarsPerChart()/2;
   
   double TreeDivide = (TreeTop - TreeBottom)/3;

   int Increment = 7;
   int Increment_2 = Increment+5;
   int Increment_3 = Increment_2+6; 

// Tree1 ------------------------------------------------------------

   double Bottom_1 = TreeBottom + TreeDivide*2;

   int Tree_Right_1 = Base-Increment;
   int Tree_Left_1 = Base+Increment;

   ObjectCreate(ObjName[1],OBJ_TRIANGLE,0,Time[ Tree_Right_1 ],Bottom_1, Time[ Tree_Left_1 ],Bottom_1, Time[ Base ],TreeTop);
   ObjectSet(ObjName[1],OBJPROP_COLOR,LEAF_COL);

// Tree2 ------------------------------------------------------------

   double Top_2 = Bottom_1;
   double Bottom_2 = TreeBottom + TreeDivide;
   
   int Tree_Right_2 = Base-Increment_2;
   int Tree_Left_2 = Base+Increment_2;

   // Tree2-1
   ObjectCreate(ObjName[21],OBJ_TRIANGLE,0,Time[ Tree_Right_1+3 ],Top_2, Time[ Tree_Left_1-3 ],Top_2, Time[ Base ],Bottom_2);
   ObjectSet(ObjName[21],OBJPROP_COLOR,LEAF_COL);

   // Tree2-2
   ObjectCreate(ObjName[22],OBJ_TRIANGLE,0,Time[ Tree_Right_1+3 ],Top_2, Time[ Tree_Right_2 ],Bottom_2, Time[ Base ],Bottom_2);
   ObjectSet(ObjName[22],OBJPROP_COLOR,LEAF_COL);

   // Tree2-3
   ObjectCreate(ObjName[23],OBJ_TRIANGLE,0,Time[ Tree_Left_1-3 ],Top_2, Time[ Tree_Left_2 ],Bottom_2, Time[ Base ],Bottom_2);
   ObjectSet(ObjName[23],OBJPROP_COLOR,LEAF_COL);

// Tree3 ------------------------------------------------------------

   double Top_3 = Bottom_2;
   double Bottom_3 = TreeBottom;
   
   int Tree_Right_3 = Base-Increment_3;
   int Tree_Left_3 = Base+Increment_3;

   // Tree3-1
   ObjectCreate(ObjName[31],OBJ_TRIANGLE,0,Time[ Tree_Right_2+3 ],Top_3, Time[ Tree_Left_2-3 ],Top_3, Time[ Base ],Bottom_3);
   ObjectSet(ObjName[31],OBJPROP_COLOR,LEAF_COL);

   // Tree3-2
   ObjectCreate(ObjName[32],OBJ_TRIANGLE,0,Time[ Tree_Right_2+3 ],Top_3, Time[ Tree_Right_3 ],Bottom_3, Time[ Base ],Bottom_3);
   ObjectSet(ObjName[32],OBJPROP_COLOR,LEAF_COL);

   // Tree3-3
   ObjectCreate(ObjName[33],OBJ_TRIANGLE,0,Time[ Tree_Left_2-3 ],Top_3, Time[ Tree_Left_3 ],Bottom_3, Time[ Base ],Bottom_3);
   ObjectSet(ObjName[33],OBJPROP_COLOR,LEAF_COL);

// Trunk ------------------------------------------------------------

   double TrunkLenghth = (TreeTop - TreeBottom)/6;
   // Trunk
   ObjectCreate(ObjName[5],OBJ_RECTANGLE,0,Time[ Base-2 ],TreeBottom - TrunkLenghth, Time[ Base+2 ],TreeBottom);
   ObjectSet(ObjName[5],OBJPROP_COLOR,TRUNK_COL);

// Star on the top ------------------------------------------------------------

   double StarTop = TreeTop + TreeDivide*0.8;
   double StarDivide = (TreeDivide*0.8)/11;

   double Level_1 = StarTop - StarDivide*4;
   double Level_2 = StarTop - StarDivide*7;
   double Level_3 = StarTop - StarDivide*9;
   double Level_Bottom = TreeTop;

   // Left
   int Left_1 = Base + 1;
   int Left_2 = Base + 2;
   int Left_3 = Base + 3;
   int Left_4 = Base + 4;

   // Right
   int Right_1 = Base - 1;
   int Right_2 = Base - 2;
   int Right_3 = Base - 3;
   int Right_4 = Base - 4;

   // Star1 - Top
   ObjectCreate(ObjName[41],OBJ_TRIANGLE,0,Time[ Right_1 ],Level_1, Time[ Left_1 ],Level_1, Time[ Base ],StarTop);
   ObjectSet(ObjName[41],OBJPROP_COLOR,TOPSTAR_COL);

   // Star2 - Leftt
   ObjectCreate(ObjName[42],OBJ_TRIANGLE,0,Time[ Left_1 ],Level_1, Time[ Left_4 ],Level_1, Time[ Left_2 ],Level_2);
   ObjectSet(ObjName[42],OBJPROP_COLOR,TOPSTAR_COL);
   
   // Star3 - Right
   ObjectCreate(ObjName[43],OBJ_TRIANGLE,0,Time[ Right_1 ],Level_1, Time[ Right_4 ],Level_1, Time[ Right_2 ],Level_2);
   ObjectSet(ObjName[43],OBJPROP_COLOR,TOPSTAR_COL);
   
   // Star4 - Bottom Right
   ObjectCreate(ObjName[44],OBJ_TRIANGLE,0,Time[ Base ],Level_3, Time[ Right_3 ],Level_Bottom, Time[ Right_2 ],Level_2);
   ObjectSet(ObjName[44],OBJPROP_COLOR,TOPSTAR_COL);
   
   // Star5 - Bottom Left
   ObjectCreate(ObjName[45],OBJ_TRIANGLE,0,Time[ Base ],Level_3, Time[ Left_3 ],Level_Bottom, Time[ Left_2 ],Level_2);
   ObjectSet(ObjName[45],OBJPROP_COLOR,TOPSTAR_COL);

   // Star6 - Hole Left
   ObjectCreate(ObjName[46],OBJ_TRIANGLE,0,Time[ Base ],Level_3, Time[ Left_1 ],Level_1, Time[ Left_2 ],Level_2);
   ObjectSet(ObjName[46],OBJPROP_COLOR,TOPSTAR_COL);

   // Star7 - Hole Center
   ObjectCreate(ObjName[47],OBJ_TRIANGLE,0,Time[ Right_1 ],Level_1, Time[ Left_1 ],Level_1,Time[ Base ],Level_3);
   ObjectSet(ObjName[47],OBJPROP_COLOR,TOPSTAR_COL);

   // Star8 - Hole Right
   ObjectCreate(ObjName[48],OBJ_TRIANGLE,0,Time[ Right_1 ],Level_1, Time[ Right_2 ],Level_2, Time[ Base ],Level_3);
   ObjectSet(ObjName[48],OBJPROP_COLOR,TOPSTAR_COL);

// Ornaments ------------------------------------------------------------

   color LIGHT_COL1 = White;
   color LIGHT_COL2 = LightPink;
   color LIGHT_COL3 = Yellow;
   color LIGHT_COL4 = White;
   color LIGHT_COL5 = Yellow;

   double LightHeight = (TreeTop - TreeBottom)/40;
   
   int VOLUME = Volume[0];
   int Tick = VOLUME % 2;
//   int Twinkle = TimeLocal() % Twinkle_Interval_Sec;
//   if(Twinkle == 0)
//   { if(SIGNAL) SIGNAL = false; else SIGNAL = true; }
   
   // 
   if( Tick == 0 )
   {
      // Light-1
      ObjectCreate(ObjName[51],OBJ_RECTANGLE,0,Time[ Left_1 ],(TreeTop+Top_2)/2, Time[ Base ], (TreeTop+Top_2)/2 + LightHeight);
      ObjectSet(ObjName[51],OBJPROP_COLOR,LIGHT_COL1);

      // Light-2
      ObjectCreate(ObjName[52],OBJ_RECTANGLE,0,Time[ Right_2 ],Top_2 , Time[ Right_1 ], Top_2 + LightHeight);
      ObjectSet(ObjName[52],OBJPROP_COLOR,LIGHT_COL2);

      // Light-3
      ObjectCreate(ObjName[53],OBJ_RECTANGLE,0,Time[ Left_4 ],(Top_2+Top_3)/2, Time[ Left_3 ], (Top_2+Top_3)/2 + LightHeight);
      ObjectSet(ObjName[53],OBJPROP_COLOR,LIGHT_COL3);

      // Light-4
      ObjectCreate(ObjName[54],OBJ_RECTANGLE,0,Time[ Right_3 ],Top_3, Time[ Right_4 ], Top_3 + LightHeight);
      ObjectSet(ObjName[54],OBJPROP_COLOR,LIGHT_COL4);

      // Light-5
      ObjectCreate(ObjName[55],OBJ_RECTANGLE,0,Time[ Left_2 ],(Top_3+TreeBottom)/2, Time[ Left_3 ], (Top_3+TreeBottom)/2 + LightHeight);
      ObjectSet(ObjName[55],OBJPROP_COLOR,LIGHT_COL5);

      // Light-6
      ObjectCreate(ObjName[56],OBJ_RECTANGLE,0,Time[ Right_4 - 4 ],(Top_3+TreeBottom)/2, Time[ Right_4 - 5 ], (Top_3+TreeBottom)/2 + LightHeight);
      ObjectSet(ObjName[56],OBJPROP_COLOR,LIGHT_COL1);

      // Light-7
      ObjectCreate(ObjName[57],OBJ_RECTANGLE,0,Time[ Left_4 + 3 ],(Top_3+TreeBottom*2)/3, Time[ Left_4 + 2 ], (Top_3+TreeBottom*2)/3 + LightHeight);
      ObjectSet(ObjName[57],OBJPROP_COLOR,LIGHT_COL3);

   }   

   if( Tick == 1 )
   {
      // Light-1
      ObjectCreate(ObjName[51],OBJ_RECTANGLE,0,Time[ Right_1 ],(TreeTop+Top_2)/2, Time[ Base ], (TreeTop+Top_2)/2 + LightHeight);
      ObjectSet(ObjName[51],OBJPROP_COLOR,LIGHT_COL3);

      // Light-2
      ObjectCreate(ObjName[52],OBJ_RECTANGLE,0,Time[ Left_2 ],Top_2 , Time[ Left_1 ], Top_2 + LightHeight);
      ObjectSet(ObjName[52],OBJPROP_COLOR,LIGHT_COL4);

      // Light-3
      ObjectCreate(ObjName[53],OBJ_RECTANGLE,0,Time[ Right_4 ],(Top_2+Top_3)/2, Time[ Right_3 ], (Top_2+Top_3)/2 + LightHeight);
      ObjectSet(ObjName[53],OBJPROP_COLOR,LIGHT_COL5);

      // Light-4
      ObjectCreate(ObjName[54],OBJ_RECTANGLE,0,Time[ Left_3 ],Top_3, Time[ Left_4 ], Top_3 + LightHeight);
      ObjectSet(ObjName[54],OBJPROP_COLOR,LIGHT_COL4);

      // Light-5
      ObjectCreate(ObjName[55],OBJ_RECTANGLE,0,Time[ Right_2 ],(Top_3+TreeBottom)/2, Time[ Right_3 ], (Top_3+TreeBottom)/2 + LightHeight);
      ObjectSet(ObjName[55],OBJPROP_COLOR,LIGHT_COL3);

      // Light-6
      ObjectCreate(ObjName[56],OBJ_RECTANGLE,0,Time[ Left_4 + 3 ],(Top_3+TreeBottom)/2, Time[ Left_4 + 4 ], (Top_3+TreeBottom)/2 + LightHeight);
      ObjectSet(ObjName[56],OBJPROP_COLOR,LIGHT_COL2);

      // Light-7
      ObjectCreate(ObjName[57],OBJ_RECTANGLE,0,Time[ Right_4 - 3 ],(Top_3+TreeBottom*2)/3, Time[ Right_4 - 2 ], (Top_3+TreeBottom*2)/3 + LightHeight);
      ObjectSet(ObjName[57],OBJPROP_COLOR,LIGHT_COL1);

   }   

   switch(Mode)
   {
      case 1: ObjectDelete("MESSAGE"); break;
      case 2: DrawMessage(); break;
      case 3: DrawLyrics(); break;
      default: DrawMessage(); break;
   }
}

//+------------------------------------------------------------------+
//| DrawMessage                                                      |
//+------------------------------------------------------------------+
void DrawMessage()
{
   string Message = CustomMessage;
   string CurLang = "Custom";
      
   int LangNum = ArraySize(Multi_Lang)-1;

   if( CustomMessage == "enter your words here" )
   {
      int LANG = Select_Language;
      if( Select_Language < 1 || Select_Language > LangNum ) LANG = 1;
      Message = Multi_Lang [ LANG ]+ " Traders !";
      CurLang = Language [ LANG ];
   }

   if( Select_Language == 99 && CustomMessage == "enter your words here" )
   {
      double Timing = ( TimeLocal() % ( LangNum * Loop_Interval_Sec) )/Loop_Interval_Sec;
      int TIMING = Timing+1;
      //Comment( "Timing = "+DoubleToStr(Timing,2)+" / TIMING = "+DoubleToStr(TIMING,0)+" / the number of Languages = "+LangNum );
      Message = Multi_Lang [ TIMING ] + " Traders !";
      CurLang = Language [ TIMING ] ;
   }

   if(ShowCurrentLanguage) Comment( "Language = "+CurLang );
   
   string OBJNAME = "MESSAGE";
   
   if (ObjectFind(OBJNAME) != 0)
      {
         ObjectCreate(OBJNAME, OBJ_LABEL, 0, 0, 0);
      	ObjectSet(OBJNAME, OBJPROP_CORNER, 2);
      	ObjectSet(OBJNAME, OBJPROP_XDISTANCE, 10);
         ObjectSet(OBJNAME, OBJPROP_YDISTANCE, 12);       
      }
   else
      {         
         ObjectSetText(OBJNAME, Message, FontSize, Font, FontColor);
      }
}

string Deutsch [] =
{  
"",
"\"Stille Nacht, heilige Nacht\"",
"",
"1.",
"Stille Nacht, heilige Nacht,",
"Alles schlaft, einsam wacht",
"Nur das traute, hochheilige Paar,",
"Holder Knabe im lockigen Haar",
"Schlafe in himmlischer Ruh!",
"Schlafe in himmlischer Ruh!",

"2.",
"Stille Nacht, heilige Nacht,",
"Gottes Sohn, o wie lacht",
"Lieb\' aus deinem gottlichen Mund,",
"Da uns schlagt die rettende Stund'",
"Christ, in Deiner Geburt!",
"Christ, in Deiner Geburt!",

"3.",
"Stille Nacht, heilige Nacht",
"Die der Welt Heil gebracht",
"Aus des Himmels goldenen Hohn",
"Uns der Gnaden Fulle last sehn",
"Jesus in Menschengestalt",
"Jesus in Menschengestalt",

"4.",
"Stille Nacht, Heilige Nacht",
"Wie sich heut alle Macht",
"vaterlicher Liebe ergos",
"und als Bruder huldvoll umschloss",
"Jesus die Volker der Welt",
"Jesus die Volker der Welt",

"5.",
"Stille Nacht, heilige Nacht",
"Lange uns schon bedacht",
"als der Herr vom Grimme befreit",
"in der Vater urgrauer Zeit",
"aller Welt Schonung verhies",
"aller Welt Schonung verhies",

"6.",
"Stille Nacht, heilige Nacht",
"Hirten erst kundgemacht",
"Durch der Engel Alleluja,",
"Tont es laut bei Ferne und Nah:",
"Jesus der Retter ist da!",
"Jesus der Retter ist da!"
};

string English [] =
{  
"",
"\"Silent night, holy night\"",
"",
"1.",
"Silent night, holy night,",
"All is calm, All is bright",
"Round yon virgin mother and Child.",
"Holy Infant so tender and mild,",
"Sleep in heavenly peace,",
"Sleep in heavenly peace.",

"2.",
"Silent night, holy night,",
"Shepherds quake at the sight.",
"Glories stream from heaven a far,",
"Heavenly hosts sing al-le-lu-ia;",
"Christ the Savior is born!",
"Christ the Savior is born!",

"3.",
"Silent night, holy night,",
"Son of God, love\'s pure light",
"Radiant beams from Thy holy face,",
"With the dawn of redeeming grace,",
"Jesus, Lord, at Thy birth,",
"Jesus, Lord, at Thy birth.",

"4.",
"Silent night! holy night!",
"Where today all the might",
"Of His fatherly love us graced",
"And then Jesus, as brother embraced.",
"All the peoples on earth!",
"All the peoples on earth!",

"5.",
"Silent night! Holy night!",
"Long we hoped that He might,",
"As our Lord, free us of wrath,",
"Since times of our fathers He hath",
"Promised to spare all mankind!",
"Promised to spare all mankind!",

"6.",
"Silent night! Holy night!",
"Sheperds first see the sight.",
"Told by angelic Alleluja,",
"Sounding everywhere, both near and far:",
"Christ the Savior is here!",
"Christ the Savior is here!"
};

string Francaise [] =
{  
"",
"\"Nuit de Paix\"",
"",
"1.",
"O nuit de paix, Sainte nuit",
"Dans le ciel L\'astre luit",
"Dans les champs tout repose en paix",
"Mais soudain dans l\'air pur et frais",
"Le brillant coeur des anges",
"Aux bergers apparait",

"2.",
"O nuit de foi, Sainte nuit",
"Les bergers sont instruits",
"Confiants dans la voix des cieux",
"Ils s\'en vont adorer leur Dieu",
"Et Jesus, en echange",
"Leur sourit radieux",

"3.",
"O nuit d\'amour, Sainte nuit",
"Dans l\'etable, aucun bruit",
"Sur la paille, est couche l\'enfant",
"Que la Vierge endort en chantant",
"Il repose en ses langes",
"Son Jesus ravissant",

"4.",
"O nuit d\'espoir, Sainte nuit",
"L\'esperance a reluit",
"Le Sauveur de la terre est ne",
"C\'est a nous que Dieu l\'a donne",
"Celebrons ses louanges",
"Gloire au Verbe incarne"
};

string Espagnol [] =
{  
"",
"\"Noche de Paz\"",
"",
"1.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor.",
"Entre sus astros que esparcen su luz",
"Bella anunciando al ninito Jesus",
"Brilla la estrella de paz",
"Brilla la estrella de paz",

"2.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor",
"Solo velan en la oscuridad",
"Los pastores que en el campo estan;",
"Y la estrella de Belen",
"Y la estrella de Belen",

"3.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor;",
"sobre el santo nino Jesus",
"Una estrella esparce su luz,",
"Brilla sobre el Rey",
"Brilla sobre el Rey.",

"4.",
"Noche de paz, noche de amor,",
"Todo duerme en derredor",
"Fieles velando alli en Belen",
"Los pastores, la madre tambien.",
"Y la estrella de paz",
"Y la estrella de paz"
};

string Italiano [] =
{  
"",
"\"Astro del Ciel\"",
"",
"1.",
"Astro del ciel, Pargol divin,",
"Mite Agnello Redentor!",
"Tu che i Vati da lungi sognar,",
"Tu che angeliche voci nunziar,",
"Luce dona alle genti",
"Pace infondi nei cuor!",
"Luce dona alle genti,",
"Pace infondi nei cuor!",
"2.",
"Astro del ciel, Pargol divin,",
"Mite Agnello Redentor!",
"Tu di stirpe regale decor,",
"Tu virgineo, mistico fior,",
"Luce dona alle genti,",
"Pace infondi nei cuor!",
"Luce dona alle genti,",
"Pace infondi nei cuor!",
"3.",
"Astro del ciel, Pargol divin,",
"Mite Agnello Redentor!",
"Tu disceso a scontare l\'error,",
"Tu sol nato a parlare d\'amor,",
"Luce dona alle menti,",
"Pace infondi nei cuor!",
"Luce dona alle genti,",
"Pace infondi nei cuor!"
};

string Norwegian [] =
{  
"",
"\"Glade Jul\"",
"",
"1.",
"Glade jul, hellige jul!",
"Engler daler ned i skjul.",
"Hit de flyver med paradis gront,",
"hvor de ser hva for Gud er skjont.",
"Lonnlig i blant oss de gar.",
"Lonnlig i blant oss de gar.",

"2.",
"Julefryd, evig fryd,",
"hellig sang med himmelsk lyd!",
"Det er engler som hyrdene sa,",
"dengang Herren i krybben la.",
"Evig er englenes sang.",
"Evig er englenes sang.",

"3.",
"Fred pa jord, fryd pa jord,",
"Jesusbarnet i blant oss bor.",
"Engler synger om barnet sa smukt,",
"han har himmeriks dor oppslukt.",
"Salig er englenes sang.",
"Salig er englenes sang.",

"4.",
"Salig fred, himmelsk fred,",
"toner julenatt herned.",
"Engler bringer til store og sma",
"bud om ham som i krybben la.",
"Fryd deg hver sjel han har frelst!",
"Fryd deg hver sjel han har frelst!"
};

string Tahitian [] =
{  
"",
"\"I te hoe po hau maru\"",
"",
"1.",
"I te hoe po hau maru",
"Ua fanau mai Iesu, ",
"Ite maira te mau fetia ",
"I te Tamaiti a te Atua",
"Te Arii fanau Api o te taata nei.",
"2.",
"I te hoe po hau maru",
"Ua fanau mai Iesu",
"Himene maira te mau helahi",
"I te arue--Al--le--lu--ia,",
"Ua fanau te Mesia, oia te Fatu mau.",
};

string Hindi [] =
{  
"",
"\"Khamosh hai raath\'\" ",
"",
"1.",
"Khamosh hai raath, Bhakth hai raath,",
"Har cheeze hai chup, har cheeze hai saanth,",
"Maa aur bete ke taur per,",
"Dhanya Sishu ko pranam kar,",
"Jes\'u tere janam per, ",
"Jes\'u tere janam per.",
"2.",
"Khamosh hai raath, Bhakth hai raath,",
"Bhedwan dekhe woh pahali nishan,",
"Pariyon ki geeth Alleluia.",
"Bulaye kinare aur dur se,",
"Dekh, dekho yeh Sishu ko,",
"Jnam liya hai Jes\'u "
};

string Euskera [] =
{  
"",
"\"Gau ixilla, gau donea\'\" ",
"",
"1.",
"Gau ixilla, gau donea, ",
"Zerutik jetxi da ",
"guazen guztiyok arin arin. ",
"Aingeru eta artzayakin, ",
"gu gatik jayo dalako ",
"Jesus Belenen.",

"2.",
"Gau erdiyan abesturik ",
"aingeruak zerutik: ",
"Aintza zeruan Jainkoari ",
"pakea lurrean gizonafri, ",
"gu gatik jayo dalako ",
"Jesus Belenen.",

"3.",
"Gau erdirik, ederna ",
"artzayentzat onena, ",
"aingeru taldea gaba argitzen, ",
"gizonen artean berri ematen, ",
"gu gatik jayo dalako ",
"Jesus Belenen.",

"4.",
"Artzayakin estalpera ",
"guazen danok batera, ",
"askatxoan dago etzana, ",
"eru lurren Jaun da Jabe, ",
"gu gatik jayo dalako ",
"belengo zoriona.",

"5.",
"Gau santua, gau donea! ",
"Jainkoa jetxi da ",
"zeru goi - goitik estalpera, ",
"izaretatik seaskatxora, ",
"lo dago Jesus Aurra, ",
"lo dago Jesus Aurra."
};

string Swahili [] =
{  
"",
"\"Usiku Mtakatifu\'\" ",
"",
"1.",
"Usiku mtakatifu! ",
"Wengine walala ",
"wakeshao ni Yosefu tu ",
"na Maria waliomlinda ",
"Yesu mwana mzuri ",
"Yesu mwana mzuri. ",

"2.",
"Usiku mtakatifu! ",
"Wachunga wapewa ",
"habari nzuri na malaika, ",
"zienezwe popote sasa: ",
"Yesu mponya kaja ",
"Yesu mponya kaja. ",

"3.",
"Usiku mtakatifu! ",
"Siku ya furaha ",
"imetuangaza Kimungu ",
"tumeupewa ukombozi ",
"Kristo amefika ",
"Kristo amefika."
};

string Indonesian [] =
{  
"",
"\"Malam Kudus\'\" ",
"",
"1.",
"Malam kudus, sunyi senyap, ",
"bintang-Mu gemerlap ",
"Jurus\'lamat manusia, ",
"ada datang di dunia ",
"Kristus Anak Daud, ",
"Kristus Anak Daud.",

"2.",
"Anak kecil, Anak kudus, ",
"Tuhanku Penebus ",
"Tent\'ra surga menyanyi merdu, ",
"bawa kabar kedatangan-Mu ",
"Kristus Anak Daud, ",
"Kristus Anak Daud.",

"3.",
"Malam kudus, sunyi senyap, ",
"bitang-Mu gemerlap ",
"Aku datang ya Tuhanku, ",
"bersembahyang di kandang-Mu ",
"Dan mengucap syukur, ",
"dan mengucap syukur. "
};

string Maori [] =
{  
"",
"\"Marie te po, tapu te po\'\" ",
"",
"1.",
"Marie te po, tapu te po,",
"Marino, marama,",
"Ko te Whaea, me te Tama,",
"Tama tino, tapu ra,",
"Moe mai i te aio,",
"Moe mai i te aio.",

"2.",
"Marie te po, tapu te po,",
"Ka kite nga hepara,",
"Te kororia o te rangi,",
"Me nga ahera Hareruia,",
"Kua whanau te tamaiti,",
"E Ihu te Karaiti."
};

string Hungarian [] =
{  
"",
"\"Csendes Ej\'\" ",
"",
"1.",
"Csendes ej! Szentseges ej!",
"Mindenek nyugta mely;",
"Nincs fenn mas, csak a Szent szulepar,",
"Draga kisdeduk almainal,",
"Szent Fiu, aludjal, szent Fiu aludjal!",

"Csendes ej! Szentseges ej!",
"Angyalok hangja kel;",
"Halld a mennyei hallelujat,",
"Szerte zengi e draga szavat,",
"Krisztus megszabadit, Krisztus megszabadit!",

"Csendes ej! Szentseges ej!",
"Sziv orulj, higyj, remelj!",
"Isten Szent Fia hinti read,",
"Ajka vigyszt ado mosolyat,",
"Krisztus megszuletett, Krisztus megszuletett!"
};

string Irish [] =
{  
"",
"\"Oiche Chiuin\'\" ",
"",
"1.",
"Oiche Chiuin, oiche Mhic De, ",
"Cach na suan go heiri an lae. ",
"Dis is dilse ag faire le speis. ",
"Glor binn aingeal le clos insan aer. ",
"Criost ag teacht ar an saol. ",
"Criost ag teacht ar an saol.",

"2.",
"Oiche Chiuin, oiche Mhic De, ",
"Aoiri ar dtus a chuala an sceal ",
"Alleluia aingeal ag glaoch ",
"Cantain suairc i ngar is i gcein. ",
"Criost ar Slanaitheoir fein ",
"Criost ar Slanaitheoir fein",
};

string Esperanto [] =
{  
"",
"\"Sanktan Nokt\'\" ",
"",
"1.",
"Paca nokt\', sankta nokt\', ",
"Brila lum\' sur la mont\'; ",
"Jen la Infano kun ama Patrin\'; ",
"Dolae Ti flustras lulante Lin, ",
"Dormu en aiela trankvil\', ",
"Dormu en aiela trankvil\'.\" ",

"2.",
"Paca nokt\', sankta nokt\', ",
"Tremas tafistoj pro la vid\'; ",
"Gloro fluas en fora aiel\'; ",
"Haleluj\'\" kantas aiu anoel\', ",
"Venis Kris\', la Savanto, ",
"Venis sanktega hel\'!\" ",

"3.",
"Paca nokt\', sankta nokt\', ",
"Dia fil\', pura bril\'; ",
"Am\' radias de sankta mien\'; ",
"Jen tagio\' de savanta ben\' ",
"Pro naskio\' de l\' Sinjoro, ",
"Pro naskio\' de l\' Sinjor\'. "
};

string HymnLang [] =
{ "",
"Deutsch","English","Francaise","Espagnol","Italiano",
"Norwegian","Tahitian","Hindi", "Euskera","Swahili",
"Indonesian", "Maori","Hungarian","Irish","   ",
"   ","   ","   ","   ", "Esperanto"
};

string LoopMerry [] = {
"Merry Christmas", // ENG
"Joyeux Noel", // FRA
"Feliz Navidad", // ESP
"Froehliche Weihnachten", // GER
"S Rozhdestvom Kristovym", // RUS

"Buon Natale", // ITA
"Shub Badadin", // Hindi
"Sheng Dankuai Le", // Mandarin
"Idah Saidan Wa Sanah Jadidah", // Iraqi
"Mele Kalikimaka", // Hawaiian

"Hauskaa Joulua", // Suomeksi
"Heri ya Krismasi", // Swahili
"Maligayang Pasko", // Tagalog
"Yangi Yiligiz Mubarak Bolsun", // Uzbek
"Velike Vanoce", // Czech
                         
"Kala Christouyenna", // Greek
"Noeliniz Ve Yeni Yiliniz Kutlu Olsun", // Turkish
"Hacahi Ke Eide", // Punjabi
"Zorionak eta Urte Berri On", // Euskera
"Gojan Kristnaskon" // Esperanto
};

string LoopMerryLang [] = {
"English","Francaise","Espagnol","Deutsch","Ruski",
"Italiano","Hindi","Chinese (Mandarin)", "Iraqi","Hawaiian",
"Suomeksi", "Swahili","Tagalog","Uzbek","Czech",
"Greek","Turkish","Punjabi","Euskera", "Esperanto"
};
//+------------------------------------------------------------------+
//| DrawLyrics                                                       |
//+------------------------------------------------------------------+
void DrawLyrics()
{
   int ARRAY_SIZE;
   
   // 1=Deutsch, 2=English, 3=Francaise, 4=Espagnol, 5=Italiano, 6=Norwegian, 7=Tahitian, 8=Hindi, 9=Euskera 10=Swahili
   // 11=Indonesian, 12=Maori, 13=Hungarian, 14=Irish, 20=Esperanto
   switch(Select_Song)
   {
      case 1: ARRAY_SIZE = ArraySize(Deutsch); break;
      case 2: ARRAY_SIZE = ArraySize(English); break;
      case 3: ARRAY_SIZE = ArraySize(Francaise); break;
      case 4: ARRAY_SIZE = ArraySize(Espagnol); break;
      case 5: ARRAY_SIZE = ArraySize(Italiano); break;
      case 6: ARRAY_SIZE = ArraySize(Norwegian); break;
      case 7: ARRAY_SIZE = ArraySize(Tahitian); break;
      case 8: ARRAY_SIZE = ArraySize(Hindi); break;
      case 9: ARRAY_SIZE = ArraySize(Euskera); break;
      case 10: ARRAY_SIZE = ArraySize(Swahili); break;
      case 11: ARRAY_SIZE = ArraySize(Indonesian); break;
      case 12: ARRAY_SIZE = ArraySize(Maori); break;
      case 13: ARRAY_SIZE = ArraySize(Hungarian); break;
      case 14: ARRAY_SIZE = ArraySize(Irish); break;

      case 20: ARRAY_SIZE = ArraySize(Esperanto); break;
      case 99: ARRAY_SIZE = ArraySize(LoopMerry); break;
      default: ARRAY_SIZE = ArraySize(Deutsch); break;
   }

   string Text;

   double Timing = ( TimeLocal() % (ARRAY_SIZE * Hymn_Interval_Sec) ) / Hymn_Interval_Sec;
   int TIMING = Timing;

   if(CurTiming == TIMING) return(0);
   CurTiming = TIMING;

   string CurLang;
   if(Select_Song != 99) CurLang = HymnLang [ Select_Song ];
   if(Select_Song == 99) CurLang = LoopMerryLang [ TIMING ];

   ObjectDelete("MESSAGE");
   if( Text != "" )
   {
      int CORNER = TextCorner % 4;
      int TEXTSHIFT_V = 12+(TextLineShift*(FontSize+2));
      int TEXTSHIFT_H = 12;
      int FONTSIZE = FontSize;

      if(Randomize)
      {
         MathSrand(TimeLocal());
         CORNER = MathRand() % 4;
         TEXTSHIFT_V = (MathRand() % 200) + 12;
         TEXTSHIFT_H = (MathRand() % 200) + 12;
         FONTSIZE = (MathRand() % (MaximumTextSize - MinimumTextSize)) + MinimumTextSize;
      }

   switch(Select_Song)
   {
      case 1: Text = Deutsch [ TIMING ]; break;
      case 2: Text = English [ TIMING ]; break;
      case 3: Text = Francaise [ TIMING ]; break;
      case 4: Text = Espagnol [ TIMING ]; break;
      case 5: Text = Italiano [ TIMING ]; break;
      case 6: Text = Norwegian [ TIMING ]; break;
      case 7: Text = Tahitian [ TIMING ]; break;
      case 8: Text = Hindi [ TIMING ]; break;
      case 9: Text = Euskera [ TIMING ]; break;
      case 10: Text = Swahili [ TIMING ]; break;
      case 11: Text = Indonesian [ TIMING ]; break;
      case 12: Text = Maori [ TIMING ]; break;
      case 13: Text = Hungarian [ TIMING ]; break;
      case 14: Text = Irish [ TIMING ]; break;

      case 20: Text = Esperanto [ TIMING ]; break;
      case 99: Text = LoopMerry [ TIMING ]+" !"; break;
      default: Text = Deutsch [ TIMING ]; CurLang = HymnLang [ 1 ]; break;
   }

   if(ShowCurrentLanguage) Comment( "Language = " + CurLang );

   string OBJNAME = "MESSAGE";
   
   if (ObjectFind(OBJNAME) != 0)
      {
         ObjectCreate(OBJNAME, OBJ_LABEL, 0, 0, 0);
      	ObjectSet(OBJNAME, OBJPROP_CORNER, CORNER);
      	ObjectSet(OBJNAME, OBJPROP_XDISTANCE, TEXTSHIFT_H);
         ObjectSet(OBJNAME, OBJPROP_YDISTANCE, TEXTSHIFT_V);       
         ObjectSetText(OBJNAME, Text, FONTSIZE, Font, FontColor);
      }
   else
      {         
         ObjectSetText(OBJNAME, Text, FONTSIZE, Font, FontColor);
      }
   }
}

